Redmine - Defect #7047

Git adapter very slow when a commit modifies a lot of files

2010-12-05 00:09 - Jean-Baptiste Barth

Status: New Start date: 2010-12-04
Priority: Low Due date:

Assignee: % Done: 0%
Category: SCM Estimated time: 0.00 hour
Target version:

Resolution: Affected version:

Description

I have a Git repo with thousands of files modified in some commits. Repository index action is very slow (>20s).

At first sight, it seems it's due to Redmine::Scm::Adapters::GitAdapter#revisions uses --raw option, which is not needed in all cases,

at least not needed in Repository::Git#latest_changesets. It results in thousands of useless lines parsed after the shell-out.

I'l have a look at that. | admit it's not a common use case, hence the priority.

Related issues:

Related to Redmine - Defect #1435: slow display of 'repository' tab for huge ...
Related to Redmine - Defect #5096: Redmine hangs up while browsing Git reposi...
Related to Redmine - Defect #4773: Redmine+Git+PostgresSQL 8.4 fails with lin...
Related to Redmine - Feature #6092: Truncate Git revision labels in Activity ...
Related to Redmine - Defect #5357: Git: SCM revisions ordered by date/time (s...
Related to Redmine - Defect #6013: git tab,browsing, very slow -- even after ...
Related to Redmine - Feature #8365: Git: per project setting to report last c...

Closed
Closed
Closed
Closed
New

Closed
Closed

2008-06-12
2010-03-16
2010-02-09
2010-08-09
2010-04-20
2010-08-02
2011-05-13

Associated revisions

Revision 4797 - 2011-02-04 11:24 - Toshi MARUYAMA

scm: change key name of configurable command name (#7517, #6159, #7047).

Revision 4851 - 2011-02-16 12:16 - Toshi MARUYAMA

scm: git: implement find_changeset_by_name (#7047).

SQL "like" is slow.

Revision 4945 - 2011-02-24 14:01 - Toshi MARUYAMA

scm: git: add flag of disable showing last commit in repository tree (#7047).

Revision 5639 - 2011-05-04 20:07 - Toshi MARUYAMA

scm: git: split adapter entries() for browsing tree performance (#7047).

Revision 5640 - 2011-05-04 20:07 - Toshi MARUYAMA

scm: git: override adapter entry() for browsing tree performance (#7047).

Revision 5641 - 2011-05-04 20:08 - Toshi MARUYAMA

scm: git: call entries_git() in adapter entriese() for browsing tree performance (#7047).

Revision 5642 - 2011-05-04 20:09 - Toshi MARUYAMA

scm: git: call entries_git() in adapter entry() for browsing tree performance (#7047).

cat/diff/blame link calls adapter entry().
Abstract adapter entry() calls adapter entries().
Git adapter entries() is very slow.

Revision 5654 - 2011-05-05 13:42 - Toshi MARUYAMA
scm: git: use report_last_commit option in unit adapter test (#7047).

Revision 5655 - 2011-05-05 13:42 - Toshi MARUYAMA

scm: git: override entries() in model for browsing tree performance (#7047).

Revision 5656 - 2011-05-05 13:43 - Toshi MARUYAMA

scm: git: add the model method whether reporting last commit in repository tree (#7047).
Revision 5657 - 2011-05-05 13:43 - Toshi MARUYAMA

scm: git: use the model value of whether reporting last commit in repository tree (#7047).
And remove entries_git() and the flag in adapter.

Revision 5661 - 2011-05-06 05:43 - Toshi MARUYAMA

scm: git: change model report_last._commit() name to extra_report_last_commit() (#7047).
Revision 5762 - 2011-05-12 19:29 - Toshi MARUYAMA
scm: add "extra_info" column to repositories table and set serialize (#7146, #7047).

This column is for specific SCM.
Git 7 days problem (#7146) can not resolve unless storing branches info in database.

Revision 5766 - 2011-05-13 01:58 - Toshi MARUYAMA

scm: add a repository model method "merge_extra_info()" to merge "extra_info" serializing hash yaml (#7146, #7047).

Revision 5767 - 2011-05-13 01:58 - Toshi MARUYAMA

scm: add a test of a repository model method "merge_extra_info()" in unit test (#7146, #7047).
Revision 5768 - 2011-05-13 05:51 - Toshi MARUYAMA
scm: git: get "extra_report_last_commit" value from extra_info (#8365, #7047).

Browsing repository tree performance problem is git only.
So, adding new "report_last_commit" column is very expensive.

Revision 5769 - 2011-05-13 05:51 - Toshi MARUYAMA

scm: switch to save repository setting params in "extra_" or not (#8365, #7047).

Revision 5770 - 2011-05-13 05:52 - Toshi MARUYAMA

scm: use repository merge_extra_info() to save extra_ parameter (#8365, #7047).

Revision 5771 - 2011-05-13 05:52 - Toshi MARUYAMA

scm: git: add check box of whether reporting last commit for files and directories in project setting (#8365, #7047).

Browsing repository tree performance problem is git only.
So, adding new "report_last_commit" column is very expensive.

Revision 5772 - 2011-05-13 05:53 - Toshi MARUYAMA

scm: git: use i18n text whether reporting last commit for files and directories in project setting (#8365, #7047).

Revision 5773 - 2011-05-13 05:54 - Toshi MARUYAMA

scm: git: add Japanese translation of whether reporting last commit for files and directories in project setting (#8365, #7047).

Revision 5774 - 2011-05-13 05:54 - Toshi MARUYAMA

scm: update locales of whether reporting last commit for files and directories in project setting (#8365, #7047).

Revision 5775 - 2011-05-13 05:55 - Toshi MARUYAMA

scm: git: show only filename and filesize if setting of reporting last commit is disable (#8365, #7047).

History
#1 - 2010-12-05 00:45 - Toshi MARUYAMA
Please see http://www.redmine.org/issues/4773#note-14 and try patch http:/www.redmine.org/attachments/3272/git-fast-browse.patch

#2 - 2010-12-05 00:52 - Toshi MARUYAMA

Please see following links.

o http://www.redmine.org/issues/1435#note-18
e http://www.redmine.org/issues/6092#note-7

#3 - 2011-02-08 02:37 - Toshi MARUYAMA

$ time wget https://www.chiliproject.org/projects/chiliproject/repository

--2011-02-08 10:33:38-- https://www.chiliproject.org/projects/chiliproject/repository

Resolving www.chiliproject.org... 184.171.175.157

Connecting to www.chiliproject.org|184.171.175.157|:443... connected.

HTTP request sent, awaiting response... 200 OK

Length: 30894 (30K) [text/html]

Saving to: “repository'

100% [ >] 30,894

——.-K/s in 0.1ls

2011-02-08 10:33:41 (213 KB/s) - “repository' saved [30894/30894]
real 0m3.378s
user Om0.063s
sys 0m0.023s

$ time wget https://www.chiliproject.org/projects/chiliproject/repository/revisions/master/show/db/migrate

--2011-02-08 10:33:54-- https://www.chiliproject.org/projects/chiliproject/repository/revisions/master/show/d
b/migrate

Resolving www.chiliproject.org... 184.171.175.157

Connecting to www.chiliproject.org|184.171.175.157|:443... connected.

HTTP request sent, awaiting response... 200 OK

Length: 139043 (136K) [text/html]
Saving to: “migrate'

100%[ >] 139,04
3 216K/s in 0.6s

2011-02-08 10:34:20 (216 KB/s) - "“migrate' saved [139043/139043]

real 0m26.036s

user Om0.068s

sys 0m0.024s

#4 - 2011-02-16 12:21 - Etienne Massip
- Assignee changed from Jean-Baptiste Barth to Toshi MARUYAMA

#5 - 2011-02-17 02:43 - Toshi MARUYAMA

The issue cannot be solved to no use of wrap git command such as Yuya's Mercurial extension.
rce:trunk/lib/redmin m, rs/mercurial/redminehelper.

#6 - 2011-03-03 09:25 - Toshi MARUYAMA

- File false_flag_report _last_commit.png added

- File true_flag_report_last_commit.png added

- Assignee deleted (Toshi MARUYAMA)

| added flag to switch showing last commit at source:trunk/lib/redmine/scm/adapters/git_adapter.rb@4992#1 25.

true

$ time wget http://localhost:3000/projects/redmine-git-00/repository/revisions/master/show/db/migrate
--2011-02-24 21:17:23-- http://localhost:3000/projects/redmine-git-00/repository/revisions/master/show/db/mig
rate

Resolving localhost... 127.0.0.1

Connecting to localhost|[127.0.0.1]:3000... connected.
http://www.redmine.org/issues/4773#note-14
http://www.redmine.org/attachments/3272/git-fast-browse.patch
http://www.redmine.org/issues/1435#note-18
http://www.redmine.org/issues/6092#note-7
https://www.redmine.org/projects/redmine/repository/svn/entry/trunk/lib/redmine/scm/adapters/mercurial/redminehelper.py
https://www.redmine.org/projects/redmine/repository/svn/revisions/4992/entry/trunk/lib/redmine/scm/adapters/git_adapter.rb#L25

HTTP request sent, awaiting response...

200 OK

Length: 139135 (136K) [text/html]

Saving to: ‘migrate’

100% [ >] 139,135
in 0.009s

2011-02-24 21:18:11 (15.5 MB/s) - 'migrate' saved [139135/139135]

real Om47.799s

user O0m0.004s

sys Om0.013s

Overview  Activity Issues New issue Gantt Calendar News Documents Wiki Files JUGEWGHIGIGE Settings
root / db / migrate illly Statistics | Branch: [master v | Tag: |
Name Size Revision Age Author

w 001_setup.rb 17.6 kB 999d4719 over 2 years Jean-Philippe Lang
W 002_issue_move.rb 421 Bytes 603e11d7 over 3 years Jean-Philippe Lang
P 003_issue_add_note.rb 417 Bytes 603e11d7 aver 3 years Jean-Philippe Lang
W 004_export_pdf.rb 745 Bytes 603e11d7 over 3 years Jean-Philippe Lang
P 005_issue_start_date.rb 202 Bytes 96f83cc8  about 4 years Jean-Philippe Lang
w 006_calendar_and_activity.rb 1006 Bytes 603e11d7 over 3 years Jean-Philippe Lang
P 007 _create_journals.rb 2.3 kB 603e11d7 aver 3 years Jean-Philippe Lang
w 008_create_user_preferences.rb 281 Bytes 96f83cc8  about 4 years Jean-Philippe Lang
“Ww 009_add_hide_mail_pref.rb 217 Bytes 96f83cc8  about 4 years Jean-Philippe Lang
w 010_create_comments.rb 524 Bytes 52547466 almost 4 years Jean-Philippe Lang
@ 011_add_news_comments_count.rb 220 Bytes 55ed7052 about 4 years Jean-Philippe Lang
W 012_add_comments_permissions.rb 751 Bytes 603e11d7 over 3 years Jean-Philippe Lang
| 013_create_queries.rb 445 Bytes 2b014258 about 4 years Jean-Philippe Lang
W 014_add_queries_permissions.rb 451 Bytes 603e11d7 over 3 years Jean-Philippe Lang
W 015_create_repositories.rb 320 Bytes bc441585  about 4 years Jean-Philippe Lang
W 016_add_repositories_permissions.rb 1.6 kB 603e11d7 over 3 years Jean-Philippe Lang
@ 017 create settinns.rb 284 Bvtes Ohdd4ddh1  abnut 4 vears lean-Philinne | ana

false

$ time wget http://localhost:3000/projects/redmine-git-00/repository/revisions/master/show/db/migrate
http://localhost:3000/projects/redmine-git-00/repository/revisions/master/show/db/mig

--2011-02-24 21:20:43--
rate

Resolving localhost... 127.0.0.1
Connecting to localhost|127.0.0.1]:3000...
HTTP request sent, awaiting response...
Length: 100345 (98K) [text/html]

Saving to: ‘migrate’

100% [

connected.

200 OK

in 0.007s

2011-02-24 21:20:45 (14.7 MB/s) - “migrate'
Om2.076s
Om0.005s

Om0.007s

real
user
sys
saved

>]

[100345/100345]

100, 345

==,=IR/8

v | | Revision: |

Use exa
Merged
Merged
Merged
trunk m
Merged
Merged
trunk m
trunk n
Fixed: *
added r
Merged
"gueries
Merged
svn bro
Merged
settinn
Overview  Activity Issues MNew issue Gantt Calendar MNews Documents Wiki Files GGG Settings

root / db / migrate il Statistics | Branch: [master v| | Tag: | v] | Revision: [
Name Size Revision Age Author Comment
P 001_setup.rb 17.6 kB
“w 002_issue_move.rb 421 Bytes
“w 003_issue_add_note.rb 417 Bytes
P 004_export_pdf.rb 745 Bytes
‘W 005_issue_start_daterb 292 Bytes
‘P 006_calendar_and_activity.rb 1006 Bytes
W 007_create_journals.rb 2.3 kB
‘P 008_create_user_preferences.rb 281 Bytes
‘P 009_add_hide_mail_pref.rb 217 Bytes
‘W 010_create_comments.rb 524 Bytes
W 011_add_news_comments_count.rb 220 Bytes
W 012_add_comments_permissions.rb 751 Bytes
W 013_create_queries.rb 445 Bytes
w 014_add_queries_permissions.rb 451 Bytes
W 015_create_repositories.rb 320 Bytes
W 016_add_repositories_permissions.rb 1.6 kB
W 017_create_settings.rb 284 Bytes
‘W 018_set_doc_and_files_notifications.rb 1 kB

| don't have a plan to refactor git adapter.
#7 - 2011-10-20 00:27 - Toshi MARUYAMA
Related issue:

https://www.chiliproject.org/i

#8 - 2013-01-13 21:04 - Jean-Philippe Lang

- Status changed from 7 to New

Assigned issue with no assignee back to New status.

Files
false_flag_report_last_commit.png 96 KB 2011-03-03 Toshi MARUYAMA
true_flag_report_last commit.png 145 KB 2011-03-03 Toshi MARUYAMA
